
            var previousUnderlineState = false;
            var previousBoldState = false;
            var previousItalicState = false;
            var previousImportantState = false;
            var previousStrikeThroughState = false;

            var previousAllignLeftState = true;
            var previousAllignCenterState = false;
            var previousAllignRightState = false;

            var previousOrderedListState = false;
            var previousUnorderedListState = false;

            var lastSelectionRange = null;

            var imageElements = function() {
                var imageNodes = document.getElementsByTagName('img');
                return [].slice.call(imageNodes);
            };


        var replaceImageSrc = function(info) {
            var images = imageElements();
            for (var i = 0; i < images.length; i++) {
                var url = images[i].getAttribute('src');
                if (url.indexOf(info.URLKey) == 0) {
                    images[i].setAttribute('src', info.LocalPathKey);
                    break;
                }
            }
        }

        var findCIDImageURL = function() {
            var images = imageElements();
            var imgLinks = [];
            for (var i = 0; i < images.length; i++) {
                var url = images[i].getAttribute('src');
                if (url.indexOf('cid:') == 0 || url.indexOf('x-mailcore-image:') == 0)
                imgLinks.push(url);
            }
            return JSON.stringify(imgLinks);
        };

        function containOriginHtml() {
            var checkbox = document.getElementById("containOriginMailHtmlCheckbox");
            checkbox.checked = !checkbox.checked;
            document.body.focus();
            if (checkbox.checked == true) {
                document.getElementById("originMailHtmlContent").style.display = "";        //显示
            } else {
                document.getElementById("originMailHtmlContent").style.display = "none";    //隐藏
            }
        }

        function lt139EmailEditStoreSelection() {
            var sel = window.getSelection();
            if (sel) {
                var range = sel.getRangeAt(0);
                if (range) {
                    lastSelectionRange = range;
                }
            } else {
                lastSelectionRange = null;
            }
        }

        function lt139EmailEditResumeSelection() {
            if(lastSelectionRange) {
                var sel = window.getSelection();
                sel.removeAllRanges();
                sel.addRange(lastSelectionRange);
                lastSelectionRange = null;
                NotifyCursorCoordinates(':3');
            }
        }

        function getCaretClientPosition() {
            var x = 0, y = 0;
            var sel = window.getSelection();
            if (sel.rangeCount) {
                var range = sel.getRangeAt(0);
                var span = document.createElement("span");
                if (span.getClientRects) {
                    // Ensure span has dimensions and position by
                    // adding a zero-width space character
                    span.appendChild(document.createTextNode("\u200b"));
                    range.insertNode(span);
                    var rect = span.getClientRects()[0];
                    var height = rect.height;
                    var spanParent = span.parentNode;
                    spanParent.removeChild(span);
                    // Glue any broken text nodes back together
                    // spanParent.normalize();
                    lt139HtmlEditorBECallbacknotifyBackend('EMAIL_EDIT_CCOORDINATES:' + rect.top + ':' + rect.bottom + ':' + rect.left + ':' + rect.right+':1');
                }
            }
            return { x: x, y: y };
        }

        document.onselectionchange = handleSelectionChanged;
        document.addEventListener("keydown", function(e) {
                                  if(webview!=null){
                                    var o = document.getElementById("main");
                                    var h = o.offsetHeight; //高度
                                    webview.onTextChanged(e.keyCode,h);
                                  }
                                  console.log(" keydown ..... keyCode: " + e.keyCode + " charCode:  " + e.charCode)

                                  if (e.keyCode == 13) {
                                     var backColor = document.queryCommandValue('backColor');
                                     if(backColor == "rgb(254, 237, 151)"){
                                        setTimeout("setRichTextStyles()",100);
                                     }
                                        getKeyCode(e.keyCode);
                                        getCaretClientPosition();
                                        handleEmptyBlockQuoteNode();
                                  }
//                                  else{
//                                      setTimeout("getCurrentRichTextStyles()",100);
//                                  }
                                  });

       //解决光标移动时样式改变，这里当输入内容时，不触发该逻辑
       var preContent = null;
       document.addEventListener("selectionchange",function(e){
          if(preContent == null){
              preContent = document.getElementById("main").innerHTML;
          }else{
              var afterContent = document.getElementById("main").innerHTML;
              if(preContent == afterContent){
                   setTimeout("getCurrentRichTextStyles()",100);
              }else{
                  preContent = document.getElementById("main").innerHTML;
              }
          }
       });


        function handleSelectionChanged() {
            checkForBIUChanges();
            NotifyCursorCoordinates(':1');
        }

        function checkForBIUChanges() {
            lt139EmailEditStoreSelection(); // keep selection stored
            var newAllignLeftState = document.queryCommandState('justifyLeft');
            var newAllignCenterState = document.queryCommandState('justifyCenter');
            var newAllignRightState = document.queryCommandState('justifyRight');

            var newOrderedListState = document.queryCommandState('InsertOrderedList');
            var newUnorderedListState = document.queryCommandState('InsertUnorderedList');

            var newItalicState = document.queryCommandState('italic');
            var newUnderlineState = document.queryCommandState('underline');
            var newBoldState = document.queryCommandState('bold');
            var newStrikeThroughState = document.queryCommandState('StrikeThrough');
            var newImportantState = false;
            var value = GetHighlightValue();//document.queryCommandValue('BackColor');
            if (value == 'rgb(255, 255, 0)') {
                newImportantState = true;
            }
            if (newItalicState != previousItalicState ||
               newUnderlineState != previousUnderlineState ||
               newBoldState != previousBoldState ||
               newImportantState != previousImportantState ||
               newStrikeThroughState != previousStrikeThroughState ||
               newAllignLeftState != previousAllignLeftState ||
               newAllignCenterState != previousAllignCenterState ||
               newAllignRightState != previousAllignRightState ||
               newOrderedListState != previousOrderedListState ||
               newUnorderedListState != previousUnorderedListState) {
                   previousUnderlineState = newUnderlineState;
                   previousBoldState = newBoldState;
                   previousItalicState = newItalicState;
                   previousImportantState = newImportantState;
                   previousStrikeThroughState = newStrikeThroughState;
                   previousAllignLeftState = newAllignLeftState;
                   previousAllignCenterState = newAllignCenterState;
                   previousAllignRightState = newAllignRightState;
                   previousOrderedListState = newOrderedListState;
                   previousUnorderedListState = newUnorderedListState;

                   var msg = 'EMAIL_EDIT_BIU_CHANGE:';
                   if(previousBoldState)
                   msg += '1';
                   else
                   msg += '0';
                   if(previousItalicState)
                   msg += '1';
                   else
                   msg += '0';
                   if(previousUnderlineState)
                   msg += '1';
                   else
                   msg += '0';
                   if(previousImportantState)
                   msg += '1';
                   else
                   msg += '0';
                   if(previousStrikeThroughState)
                   msg += '1';
                   else
                   msg += '0';
                   if(previousAllignLeftState)
                   msg += '1';
                   else
                   msg += '0';
                   if(previousAllignCenterState)
                   msg += '1';
                   else
                   msg += '0';
                   if(previousAllignRightState)
                   msg += '1';
                   else
                   msg += '0';
                   if(previousOrderedListState)
                   msg += '1';
                   else
                   msg += '0';
                   if(previousUnorderedListState)
                   msg += '1';
                   else
                   msg += '0';
                   //window.location.href = msg;
                   lt139HtmlEditorBECallbacknotifyBackend(msg);
               }
        }

        var oldClientHeight = 0;
        var email_content_change_notified = false;

        function findEditorDiv(currentElement) {
            if (currentElement == null) return null;
            if (isDivElementFHAUIFAOF(currentElement)) return currentElement;
            var i = 0;
            for (; i < currentElement.childNodes.length;i++) {
                var nextElement = currentElement.childNodes.item(i);
                var ret = findEditorDiv(nextElement);
                if (ret != null) {
                    return ret;
                }
            }
            return null;
        }

        function isDivElementFHAUIFAOF(queryElement) {
            if(queryElement.tagName) {
                if(queryElement.tagName.toUpperCase() == 'DIV') {
                    return true;
                }
            } else if (queryElement == '[object HTMLDivElement]') {
                return true;
            }
            return false;
        }

        function localImageLoaded() {
            //updateEditorWidth();
            var tmpHeight = findEditorDiv(document).clientHeight;
            setEditDivMargin(tmpHeight);
            //window.location.href = 'EMAIL_EDIT_RESIZE:';
            lt139HtmlEditorBECallbacknotifyBackend('EMAIL_EDIT_RESIZE:');
        }

        function modifiedEditorContent() {
            window.setTimeout(
                              function() {
                              checkForBIUChanges();
                              window.setTimeout(
                                                function() {
                                                if(!email_content_change_notified) {
                                                email_content_change_notified = true;
                                                //window.location.href = 'EMAIL_EDIT_CONTENT_CHANGE:';
                                                lt139HtmlEditorBECallbacknotifyBackend('EMAIL_EDIT_CONTENT_CHANGE:');
                                                }
                                                window.setTimeout(
                                                                  function() {
                                                                  var tmpHeight = findEditorDiv(document).clientHeight;
                                                                  setEditDivMargin(tmpHeight);
                                                                  if(oldClientHeight != tmpHeight)
                                                                  //window.location.href = 'EMAIL_EDIT_RESIZE:';
                                                                  lt139HtmlEditorBECallbacknotifyBackend('EMAIL_EDIT_RESIZE:');
                                                                  oldClientHeight = tmpHeight;
                                                                  window.setTimeout(
                                                                                    function() {
<!--                                                                                    NotifyCursorCoordinates(':2');-->
                                                                                    },0);
                                                                  },
                                                                  0);
                                                },
                                                0);
                              },
                              0);


        }

        //触摸事件
        function touchStart() {
//         window.setTimeout(
//             getCurrentRichTextStyles();
             //延时100毫秒，才能准确获取到样式，否则会获取到之前光标的样式，这是个大坑
             setTimeout("getCurrentRichTextStyles()",100);
        }

        function setTouchStart() {
//         window.setTimeout(
//                     setRichTextStyles();
             setTimeout("setRichTextStyles()",100);
        }

        function notifyContentLoaded() {
            findEditorDiv(document).addEventListener('DOMSubtreeModified', modifiedEditorContent, false);
            window.setTimeout(
                              function()
                              {
                              if(document.implementation.hasFeature('MutationEvents','2.0'))
                              //window.location.href = 'EMAIL_CONTENT_LOAD:TRUE';
                              lt139HtmlEditorBECallbacknotifyBackend('EMAIL_CONTENT_LOAD:TRUE');
                              else
                              //window.location.href = 'EMAIL_CONTENT_LOAD:FALSE';
                              lt139HtmlEditorBECallbacknotifyBackend('EMAIL_CONTENT_LOAD:FALSE');
                              oldClientHeight = findEditorDiv(document).clientHeight;
                              }, 0);
                              findEditorDiv(document).addEventListener('paste',
                                                                       function(e) {
                                                                       if(e.clipboardData.getData('text/uri-list')) {
                                                                       // a public uri is available, use it.
                                                                       var targetUri = e.clipboardData.getData('text/uri-list');
                                                                       //findEditorDiv(document).innerHTML = targetUri + '<br>';
                                                                       if(targetUri.lastIndexOf('.') > 0) {
                                                                       if(targetUri.length > targetUri.lastIndexOf('.')+1) {
                                                                       var lIndex = targetUri.lastIndexOf('.');
                                                                       var fextension = targetUri.slice((lIndex+1));
                                                                       fextension = fextension.toUpperCase();
                                                                       if (fextension == 'JPG' || fextension == 'JPEG' || fextension == 'PNG' || fextension == 'GIF' || fextension == 'TIFF' || fextension == 'BMP') {
                                                                       document.execCommand('insertImage', null,e.clipboardData.getData('text/uri-list'));
                                                                       e.preventDefault();
                                                                       e.stopPropagation();
                                                                       //updateEditorWidth();
                                                                       return;
                                                                       }
                                                                       }
                                                                       }
                                                                       document.execCommand('insertHtml', null, '<a href=\"' + e.clipboardData.getData('text/uri-list') + '\">' + e.clipboardData.getData('text/uri-list') + '</a>');
                                                                       e.preventDefault();
                                                                       e.stopPropagation();
                                                                       //updateEditorWidth();

                                                                       }
                                                                       if(!e.clipboardData.getData('text/uri-list') && !e.clipboardData.getData('text/plain'))
                                                                       {
                                                                       // no public uri and no plain text data, ask obj-C backend to handle
                                                                       //window.location.href = 'EMAIL_EDIT_PASTE_EVENT:';
                                                                       lt139HtmlEditorBECallbacknotifyBackend('EMAIL_EDIT_PASTE_EVENT:');
                                                                       e.preventDefault();
                                                                       e.stopPropagation();
                                                                       }
                                                                       }, false);
                                                                       // update editor width
                                                                       //updateEditorWidth();
                                                                       // the editor div should be same size as content, if div got scrolled, it is of wrong size, update
                                                                       //findEditorDiv(document).addEventListener('scroll', updateEditorWidth, false);

        }

        //function editorDivScrolled

        function updateEditorWidth() {
            window.setTimeout(
                              function() {
                              findEditorDiv(document).style.width = findEditorDiv(document).scrollWidth + 5;
                              //findEditorDiv(document).innerHTML += '<br>' + findEditorDiv(document).scrollWidth + '<br>';
                              }, 0);
        }

        _timer = setInterval(function() {
                             if (/loaded|complete|interactive/.test(document.readyState)) {
                             clearInterval(_timer);
                             var tmpHeight = findEditorDiv(document).clientHeight;
                             setEditDivMargin(tmpHeight);

                             if (oldClientHeight != tmpHeight)
                             lt139HtmlEditorBECallbacknotifyBackend('EMAIL_EDIT_RESIZE:');
                             oldClientHeight = tmpHeight;
                             }
                             }, 100);

                             function GetHighlightValue() {
                                 var sel = window.getSelection();
                                 var baseNode = sel.baseNode;
                                 var color = 'undefined';
                                 if (!baseNode) {
                                     return color;
                                 }
                                 if (sel.isCollapsed || baseNode.nodeType == Node.TEXT_NODE) {
                                     if(sel.isCollapsed) {
                                         return document.queryCommandValue('BackColor');
                                     } else {
                                         // determine based on anchor node
                                         var textContainer = sel.anchorNode;
                                         var _color = null;
                                         do {
                                             if(textContainer.style)
                                             _color = textContainer.style["background-color"];
                                             var _parent = textContainer.parentElement;
                                             if (!_color && _parent) {
                                                 textContainer = _parent;
                                                 continue;
                                             }
                                             break;
                                         } while (textContainer);
                                         if (_color) {
                                             color = _color;
                                         }
                                     }
                                 } else {

                                     var r = sel.getRangeAt(0);
                                     if (!r) {
                                         return color;
                                     }
                                     var commonAncestorContainer = r.commonAncestorContainer;
                                     if (commonAncestorContainer.nodeType != Node.ELEMENT_NODE) {
                                         commonAncestorContainer = commonAncestorContainer.parentElement;
                                     }
                                     if (!commonAncestorContainer) {
                                         return color;
                                     }
                                     var styledElements = commonAncestorContainer.querySelectorAll("*[style]");
                                     if (!styledElements) {
                                         return color;
                                     }
                                     for (var i = 0; i < styledElements.length; i++) {
                                         var styledElement = styledElements[i];
                                         if (!styledElement) {
                                             continue;
                                         }
                                         if (!r.intersectsNode(styledElement)) {
                                             continue;
                                         }
                                         if (styledElement.style["background-color"]) {
                                             color = styledElement.style["background-color"];
                                             break;
                                         }
                                     }
                                 }
                                 return color;
                             };
        function setEditDivMargin(tmpHeight) {
            var editor = findEditorDiv(document);
            if (tmpHeight > 10000) {
                editor.style.marginTop = "0px";
                editor.style.marginBottom = "0px";
            } else {
                editor.style.marginTop = "0px";
                editor.style.marginBottom = "0px";
            }
        }
        function notifyContentFocus() {
            lt139EmailEditcontentFocused = true;
            //window.location.href = 'EMAIL_EDIT_FOCUS:';
            lt139HtmlEditorBECallbacknotifyBackend('EMAIL_EDIT_FOCUS:');
        }

        function lt139EmailEditGetCurrentSelectionRectAsString() {
            var rec = lt139EmailEditGetCurrentSelectionRect();
            var retVal = '';
            if(rec) {
                retVal = rec.top + ':' + rec.bottom + ':' + rec.left + ':' + rec.right;
            }
            return retVal;
        }

        function lt139EmailEditGetCurrentSelectionRect() {
            // Disable modification event in case need to insert node, this would create some sort of loop othervice
            findEditorDiv(document).removeEventListener('DOMSubtreeModified', modifiedEditorContent);
            document.onselectionchange = null;

            var sel = document.getSelection();                  // change the selection
            var ran = sel.getRangeAt(0);                        // into a range
            var rec = ran.getClientRects()[0];                  // that we can get coordinates from
            <!--                if (rec == null) {-->
                <!--                    // Can't get coords at start of blank line, so we-->
                <!--                    // insert a char at the cursor, get the coords of that,-->
                <!--                    // then delete it again. Happens too fast to see.-->
                <!--                    ran.insertNode( document.createTextNode(".") );-->
                <!--                    rec = ran.getClientRects()[0];  // try again now that there's text-->
                <!--                    ran.deleteContents();-->
                <!--                }-->
            // re-enable event.
            document.onselectionchange = handleSelectionChanged;
            findEditorDiv(document).addEventListener('DOMSubtreeModified', modifiedEditorContent, false);
            return rec;
        }

        function NotifyCursorCoordinates(otherthing) {
            var other = '';
            if(otherthing.length>0) {
                other=otherthing;
            }
            var sel = document.getSelection();
            var rec = lt139EmailEditGetCurrentSelectionRect();

            var top = rec.top;               // Y coord of selection top edge
            var bottom  = rec.bottom;        // Y coord of selection bottom edge
            var left = rec.left;             // X coord of selection left edge
            var right = rec.right;           // X coord of selection right edge
            lt139HtmlEditorBECallbacknotifyBackend('EMAIL_EDIT_CCOORDINATES:' + rec.top + ':' + rec.bottom + ':' + rec.left + ':' + rec.right+other);
        }
        var lt139EmailEditcontentFocused = false;
        function notifyContentUnfocus() {
            lt139EmailEditcontentFocused = false;
            //lt139HtmlEditorBECallbacknotifyBackend('EMAIL_EDIT_TOUCH_END');
        }

        //光标点击监听
        window.ontouchstart=function(event) {
//        document.documentElement.ontouchstart = function(){
            touchStart();
//             getCurrentRichTextStyles();
            if (!lt139EmailEditcontentFocused)
            //window.location.href = 'EMAIL_EDIT_TOUCH_START:';
            lt139HtmlEditorBECallbacknotifyBackend('EMAIL_EDIT_TOUCH_START');
        }

        var backendMessageQueue = new Array();
        var backendmessageCount = 0;
        function lt139HtmlEditorBECallbacknotifyBackend(msg) {
            // TODO this way seems to work, but the messages may come in reversed order if passed too fast
            // if this is a problem, fix function lt139HtmlEditorBECallback.getNextMessageFromQueue
            // (at the moment the queue works with LIFO principle.

            //log(msg);
            backendMessageQueue.push(msg);
           // window.location.href = 'MESSAGE_FROM_UI:' + backendmessageCount;
            backendmessageCount++;
        };

        function lt139HtmlEditorBECallbackgetNextMessageFromQueue() {
            if(backendMessageQueue.length > 0)
            return backendMessageQueue.pop();
            return '';
        };



        /*********************************************************************************************/
        /* RickText */
        /*********************************************************************************************/


//        window.onload = function() {
//            document.onclick = function(event) {
//                getClickedElement(event);
//            }
//            /*
//             <div id="main" class="content" style="min-width:300px;padding-left:10px; min-height: 100%; overflow:auto;-webkit-tap-highlight-color: rgba(0, 0, 0, 0); margin-top: 200px; margin-bottom: 200px;margin-left:10px;margin-right:10px;font-size:16px" contenteditable="true" onfocus="notifyContentFocus()" onblur="notifyContentUnfocus()">
//             */
//        }

        // 处理空内容<blockquote>节点的回车事件
        function handleEmptyBlockQuoteNode() {
            if (isEmptyBlockQuoteNode()) {
                document.execCommand("formatBlock", false, "div");
            }
        }

        // 是否为空<blockquote>节点
        function isEmptyBlockQuoteNode() {
            return existBlockquoteStyle() && contentOfSelectedNode() == "<br>" ? true : false;
        }

        // 是否存在<blockquote>样式
        function existBlockquoteStyle() {
            var result = existStyle("blockquote");
            if (result == 1) {
                console.log("当前节点样式为<blockquote>，禁止设置其它样式");
                return true;
            } else {
                console.log("当前节点不存在<blockquote>样式");
                return false;
            }
        }

        // 获取节点内容
        function contentOfSelectedNode() {
            return getSelectedElement().innerHTML;
        }

        function typeOfNode(node) {
            return node.tagName.toLowerCase();
            // return node.prop("tagName").toLowerCase();
        }

        // 获取当前光标位置所在的元素（光标当前的位置，不一定是点击位置，有可能通过键盘光标移动）
        function getSelectedElement() {
            var node;
            var selection = document.getSelection();
            if (selection) {
                // 设置node为Selection对象的最后一个节点
                // (在iOS11以下版本，这里获取到的node为null，因此当node为空时，应返回clickedNode)
                node = selection.anchorNode;
            }
            if (!node && document.selection) {
                selection = document.selection;
                var range = selection.getRangeAt ? selection.getRangeAt(0) : selection.createRange();
                node = range.commonAncestorContainer ? range.commonAncestorContainer : null;
                range.parentElement ? range.parentElement() : range.item(0);
            }
            if (node) {
                return node.nodeName == "#text" ? node.parentNode : node;
            } else {
                return clickedNode;
            }
        }

        // 获取当前点击位置所在元素
        function getClickedElement(event) {
            var target = event.target || event.srcElement;
            clickedNode = target;
             console.log("grass 当前节点[" + clickedNode);
        }

        // 查找节点是否存在指定样式
        function existStyle(style) {
            var blockElementType = typeOfNode(firstBlockElementOfSelectedNode());
            if (blockElementType == style) {
                console.log("当前节点已存在所查找的样式[" + style + "]");
                return 1;
            } else {
                console.log("当前节点不存在所查找的样式[" + style + "]");
                return blockElementType;
            }
        }

        // 查找当前选中节点的第一个块级元素（去除<span>、<font>、<b>等内联元素类型）
        function firstBlockElementOfSelectedNode() {
            var selectedElement = getSelectedElement();
            var selectedType = typeOfNode(selectedElement);
            var blockElement = selectedElement;
            while (inlineElementTypes.indexOf(selectedType) >= 0) {
                console.log("当前节点为内联元素[" + selectedType + "]，需继续向上查找");
                blockElement = blockElement.parentNode;
                selectedType = typeOfNode(blockElement);
            }
            console.log("当前选中节点的第一个块级元素：" + blockElement);
            return blockElement;
        }

        // 是否存在<li>样式
        function existListStyle() {
            var result = existStyle("li");
            if (result == 1) {
                console.log("当前样式为<li>，禁止设置其它样式");
            } else {
                console.log("选中节点的样式[" + result + "]");
            }
            return result;
        }

        // 是否存在<h>样式
        function existHeadingStyle() {
            for (var size of headingSizes) {
                if (existStyle(size) == 1) {
                    console.log("当前节点已设置标题样式<" + size + ">，禁止设置其它样式");
                    return true;
                }
            }
            return false;
        }

        // 是否存在<blockquote>样式
        function existBlockquoteStyle() {
            var result = existStyle("blockquote");
            if (result == 1) {
                console.log("当前节点样式为<blockquote>，禁止设置其它样式");
                return true;
            } else {
                console.log("当前节点不存在<blockquote>样式");
                return false;
            }
        }

        //换行设置背景色为黄色，解决黄色背景选中状态下，换行后样式消失的问题
        function setRichTextStyles() {
             color = '#feed97';
             document.execCommand("backColor", false, color);
        }

        //获取当前字体样式
        function getCurrentRichTextStyles() {
            var selObj = window.getSelection();
//            console.log("grass selText：" + selObj.createRange);

            // 字体
            var bold = document.queryCommandState('bold');
//            console.log("grass bold：" + bold);
            var underline = document.queryCommandState('underline');
//            console.log("grass underline：" + underline);
            var italic = document.queryCommandState('italic');
//            console.log("grass italic：" + italic);
            var strikeThrough = document.queryCommandState('strikeThrough');
//            console.log("grass strikeThrough：" + strikeThrough);
            var fontSize = document.queryCommandValue('fontSize');
//            console.log("grass fontSize：" + fontSize);
            var backColor = document.queryCommandValue('backColor');
//            console.log("grass backColor：" + backColor);
            // 颜色
            var foreColor = document.queryCommandValue('foreColor');
//            console.log("grass foreColor：" + foreColor);
            // 段落
            var unorderList = getCurrentUnOrderList();
            var orderList = getCurrentOrderList();
            var paragraphLeft = getCurrentParagraphLeft();
            var paragraphCenter = getCurrentParagraphCenter();
            var paragraphRight = getCurrentParagraphRight();
            var paragraph = 0;
            if (paragraphCenter) paragraph = 1;
            if (paragraphRight) paragraph = 2;
            if (unorderList) paragraph = 3;
            if (orderList) paragraph = 4;
            // 所有状态
            dic = {"fontSize":fontSize, "bold":bold, "underline":underline, "strikeThrough":strikeThrough, "italic":italic, "backColor":backColor, "foreColor":foreColor, "paragraph":paragraph};
//            getRichTextStates(dic);
            var object = {};
            object['fontSize'] = fontSize;
            object['bold'] = bold;
            object['underline'] = underline;
            object['strikeThrough'] = strikeThrough;
            object['italic'] = italic;
            object['backColor'] = backColor;
            object['foreColor'] = foreColor;
            object['paragraph'] = paragraph;
            var json = JSON.stringify(object);
            //区分于IOS
            if(webview!=null){
               console.log("grass：" + "不为空" + json);
               //返回当前光标的样式给Android端
               webview.onTouchChanged(json);
            }
        }

        // 字体
        function getOtherFontStylesExcept(style) {
            if (style != "bold") {
                var bold = document.queryCommandState('bold');
            }
            if (style != "underline") {
                var underline = document.queryCommandState('underline');
            }
            if (style != "italic") {
                var italic = document.queryCommandState('italic');
            }
            if (style != "strikeThrough") {
                var strikeThrough = document.queryCommandState('strikeThrough');
            }
            var string = "";
            if (bold) string += "<b>";
            if (underline) string += "<u>";
            if (italic) string += "<i>";
            if (strikeThrough) string += "<strike>";
            string += "&zwnj;";
            if (bold) string += "</b>";
            if (underline) string += "</u>";
            if (italic) string += "</i>";
            if (strikeThrough) string += "</strike>";
            return string;
        }

        function getCurrentFontSize() {
            return getElementStyle(getSelectedElement(), undefined).fontSize;
        }

        // 颜色
        function getCurrentFontColor() {
            return getElementStyle(getSelectedElement(), undefined).color;
        }

        function getCurrentBackColor() {
            return getElementStyle(getSelectedElement(), undefined).backColor;
        }

        // 段落
        function getCurrentUnOrderList() {
            return document.queryCommandState('InsertUnorderedList');
        }

        function getCurrentOrderList() {
            return document.queryCommandState('InsertOrderedList');
        }

        function getCurrentParagraphLeft() {
            return document.queryCommandState('JustifyLeft');
        }

        function getCurrentParagraphCenter() {
            return document.queryCommandState('JustifyCenter');
        }

        function getCurrentParagraphRight() {
            return document.queryCommandState('JustifyRight');
        }

        function setFontShape(style) {
            var selection = window.getSelection();
            var range = selection.getRangeAt(0);
            if (document.queryCommandState(style)) {
                document.execCommand(style, false, 'div');
            } else {
                document.execCommand(style, false, null);
            }
        }

        /****************************************************************************************/

        // 编辑器对象
        var yhz_editor = {};

        // 内联元素集合
        var inlineElementTypes = ["span", "font", "b", "i", "u", "strike"];

        // 当前点击标签
        var clickedNode;

        // Heading样式值集合
        var headingSizes = ["h1", "h2", "h3"];

        var textBgdColor = 0;

        var currentSetTextColor = "#141414";

        /****************************************************************************************/

        // 获取当前光标位置所在元素（光标当前位置不一定是点击位置，有可能通过第三方输入法提供的光标移动功能来移动）
        function getSelectedElement() {
            var node;
            var selection = document.getSelection();
            if (selection) {
                // 设置node为Selection对象的最后一个节点(在iOS11以下版本，这里获取到的node为null，因此当node为空时，应返回clickedNode)
                node = selection.anchorNode;
            }
            if (!node && document.selection) {
                selection = document.selection;
                var range = selection.getRangeAt ? selection.getRangeAt(0) : selection.createRange();
                node = range.commonAncestorContainer ? range.commonAncestorContainer : null;
                range.parentElement ? range.parentElement() : range.item(0);
            }
            if (node) {
                return node.nodeName == "#text" ? node.parentNode : node;
            } else {
                return clickedNode;
            }
        }

        /* === 字型 === */

        // 加粗
        yhz_editor.setBold = function() {
            document.execCommand("bold", false, null);
        }

        // 斜体
        yhz_editor.setItalic = function() {
            document.execCommand("italic", false, null);
        }

        // 下划线
        yhz_editor.setUnderline = function() {
            document.execCommand("underline", false, null);
        }

        // 删除线
        yhz_editor.setStrikeThrough = function() {
            document.execCommand("strikeThrough", false, null);
        }

        // 字号
        yhz_editor.setFontSize = function(size) {
            document.execCommand("fontSize", false, size);
        }

        // 标题
        yhz_editor.setHeading = function(size) {
            var headingSize = existListStyle();
            if (headingSize == 1) {
                return;
            }
            var isHeading = headingSizes.indexOf(headingSize) >= 0 ? true : false;
            console.log("当前节点是否为<h>样式[" + isHeading + "] - 传入的h值[" + size + "] - 当前节点的h值[" + headingSize + "]");
            if (isHeading && size == headingSize) {
                console.log("撤销<h>样式");
                document.execCommand("formatBlock", false, "div");
            } else {
                console.log("设置<h>样式");
                document.execCommand("formatBlock", false, size);
            }
        }

        /* === 段落 === */

        // 靠左
        yhz_editor.setJustifyLeft = function() {
            document.execCommand("justifyLeft", false, null);
        }

        // 居中
        yhz_editor.setJustifyCenter = function() {
            if (existListStyle() == 1) {
                console.log("存在<li>冲突样式，禁止设置<center>样式");
                return;
            }
            document.execCommand("justifyCenter", false, null);
        }

        // 靠右
        yhz_editor.setJustifyRight = function() {
            if (existListStyle() == 1) {
                console.log("存在<li>冲突样式，禁止设置<right>样式");
                return;
            }
            document.execCommand("justifyRight", false, null);
        }

         yhz_editor.setJustifyFull = function() {
            if (existListStyle() == 1) {
                return;
            }
            document.execCommand("JustifyNone", false, null);
        }

        // 无序号列表
        yhz_editor.setUnOrderedList = function() {
            if (existHeadingStyle() || existBlockquoteStyle()) {
                console.log("存在<<h>或<blockquote>冲突样式，禁止设置<ul>样式");
                return;
            }
            yhz_editor.setJustifyLeft();
            document.execCommand("insertUnorderedList", false, null);
            yhz_editor.setTextColor(currentSetTextColor);
        }

        // 有序号列表
        yhz_editor.setOrderedList = function() {
            if (existHeadingStyle() || existBlockquoteStyle()) {
                console.log("存在<<h>或<blockquote>冲突样式，禁止设置<ul>样式");
                return;
            }
            yhz_editor.setJustifyLeft();
            document.execCommand("insertOrderedList", false, null);
            yhz_editor.setTextColor(currentSetTextColor);
        }

        // 块引用
        yhz_editor.setBlockquote = function() {
            if (existListStyle() == 1) {
                console.log("存在<li>样式，禁止插入<blockquote>样式");
                return;
            }
            document.execCommand("formatBlock", false, "<blockquote>");
        }

        // 分割线
        yhz_editor.setHorizontalRule = function() {
            if (existListStyle() == 1) {
                console.log("存在<blockquote>或<li>样式，禁止插入分割线<hr>");
                return;
            }
            document.execCommand("insertHorizontalRule", false, null);
        }

        /* === 颜色 === */

        yhz_editor.setTextForeColor = function(color) {
            document.execCommand("foreColor", false, color);
            currentSetTextColor = color;
        }

        yhz_editor.setTextBgdColor = function(color) {
//            var color;
//            if (textBgdColor) {
//                color = '#ffffff';
//                textBgdColor = 0;
//            } else {
//                color = '#feed97';
//                textBgdColor = 1;
//            }
            var backColor = document.queryCommandValue('backColor');

            if(backColor == "rgb(254, 237, 151)"){
                color = '#ffffff';
            }else{
                color = '#feed97';
            }
            document.execCommand("backColor", false, color);
        }

        /* === 图片 === */
        yhz_editor.insertImageData = function(imageDataString) {
        console.log("grass" + imageDataString);
            var html = "<div><div><br></div><img src='data:image/jpg;base64," + imageDataString + "' onclick='yhz_editor.clickImage(this)'><div><br></div></div>";
            document.execCommand("insertHTML", false, html);
//                document.getElementById("photo").src=""+imageDataString
        }

        yhz_editor.clickImage = function(img) {
            document.getElementById("main").blur();
        }
        /* === 其它 === */

        // 撤销
        yhz_editor.undo = function() {
            document.execCommand("undo", false, null);
        }

        // 重做
        yhz_editor.redo = function() {
            document.execCommand("redo", false, null);
        }

        // 在当前光标处插入html内容
        yhz_editor.insertHTML = function(html) {
            html = unescapeXml(html);
            document.execCommand("insertHTML", false, html);
            //alert(decodeURI(html));
        }

        yhz_editor.setContent = function(html) {
            html = unescapeXml(html);
            document.getElementById("main").innerHTML=html;
            return html;
        }

        unescapeXml=function(html){
            var result = html.replace(/&lt;/g, "<")
            .replace(/&gt;/g, ">")
            .replace(/&amp;/g, "&")
            .replace(/&quot;/g, '"')
            .replace(/&apos;/g, "'");
            return result;
        }
        yhz_editor.appendText = function(html) {
            html = unescapeXml(html);
            document.getElementById("main").innerHTML+=html;
        }
        yhz_editor.exportContent = function() {
            var htmlContent = document.getElementById("main").innerHTML;
            //原来了兼容4.4系统而做的导出，因为没办法用evaluateJavascript来做返回值 by vincent 20200410
            webview.exportContent(htmlContent);
            return htmlContent;
        }
        var signDivId="edit_id_sign";
        yhz_editor.setSign = function(html) {
            html = unescapeXml(html);
            var doc = document.getElementById(signDivId);
            while(doc!=null){
                doc.parentNode.removeChild(doc);
                doc = document.getElementById(signDivId);
            }
            if(doc==null){
                yhz_editor.appendText(html);
            }else{
                doc.innerHTML=html;
            }
        }
        yhz_editor.exportSign = function() {
            var sign = document.getElementById(signDivId).innerHTML;
            return sign;
        }
        //为了可以同时给正文和签名赋值
        yhz_editor.setEditContent = function(html,signText) {
            html = unescapeXml(html);
            signText = unescapeXml(signText);
            yhz_editor.appendText(html);
            yhz_editor.setSign(signText);
            return yhz_editor.exportContent();
        }

        // 检查所有正文内容是否包含<div>标签
        function checkAllContentEmbededDiv(content) {
            var htmlContent = content ? content : document.getElementById(ContentID).innerHTML;
            if (htmlContent.length == 0) {
                console.log("正文内容为空，无需查找非<div>标签正文，添加上空的<br>标签");
                document.getElementById(ContentID).innerHTML = "<div><br></div>";
            } else if (htmlContent.substr(0, 25) == "<div id=\"ContentStyleDiv\"") {
                console.log("首级标签开头已为ContentStyleDiv，无需查找非<div>标签正文");
            } else {
                console.log("开始查找没包含在<div>标签中的目标正文：\n" + htmlContent);
                if (htmlContent.substr(0, 4) != "<div") {
                    console.log("首级标签不以\"<div\"开头");
                    var firstIndex = htmlContent.indexOf("<div>");
                    if (firstIndex == -1) {
                        document.getElementById(ContentID).innerHTML = "<div>" + htmlContent + "</div>";
                        return;
                    }
                    var targetContent = htmlContent.substr(0, firstIndex);
                    var remainContent = htmlContent.substr(firstIndex);
                    document.getElementById(ContentID).innerHTML = "<div>" + targetContent + "</div>" + remainContent;
                } else {
                    console.log("首级标签以\"<div\"开头，查找中间段没包含在<div>标签中的内容");
                    var indexes = indexesOfAllSubStrings(htmlContent, "</div>");
                    for (var i = 0; i < indexes.length; ++i) {
                        var targetString = htmlContent.substr(indexes[i], 7);
                        if (targetString.length == 7 && targetString != "</div><") {
                            console.log("==> 目标字符串为\"</div>+正文内容\"，符合要求，需手动添加<div>标签");
                            var startIndex = indexes[i] + 6;
                            var endIndex = htmlContent.indexOf("<div>", indexes[i]);
                            endIndex = endIndex > 0 ? endIndex : htmlContent.length;
                            var length = endIndex - startIndex;
                            var targetContent = htmlContent.substr(startIndex, length);
                            var frontString = htmlContent.substr(0, startIndex);
                            var tailString = htmlContent.substr(endIndex);
                            document.getElementById(ContentID).innerHTML = frontString + "<div>" + targetContent + "</div>" + tailString;
                        }
                    }
                    setCursorAtTailOfSelectedNode();
                }
            }
        }

        function indexesOfAllSubStrings(longString, subString) {
            var indexes = new Array();
            var index = longString.indexOf(subString);
            while (index > -1) {
                indexes.push(index);
                index = longString.indexOf(subString, index + 1);
            }
            return indexes;
        }

        function setCursorAtTailOfSelectedNode() {
            var selObj = document.getSelection();
            if (!selObj || !getSelectedElement()) return;
            selObj.selectAllChildren(getSelectedElement());
            selObj.collapseToEnd();
        }

          /* === @联系人 === */
        function insertTempSpan(tempID) {
            yhz_editor.removeTempSpan(tempID);
            var html = "<span class='atwho-inserted' id='" + tempID + "' style='text-indent: 0.0px;'><\span>";
            document.execCommand("insertHTML", false, html);
        }

        yhz_editor.removeTempSpan = function(tempID, replaceString) {
            var tempNode = document.getElementById(tempID);
            if (tempNode) {
                if (replaceString) tempNode.before(replaceString);
                tempNode.parentNode.removeChild(tempNode);
            }
        }

        yhz_editor.insertContact = function(obj) {
            //document.getElementById("main").focus();
            //<span class='atwho-inserted' id='atInserted-手机号' style='text-indent: 0.0px;'>
            //contactsList = [[手机号,邮箱]]
            console.log("grass @" + obj);
            var contactsList = JSON.parse(obj);
            for(var i=0;i<contactsList.length;i++){
               console.log("grass @" + contactsList[i]);
            }
           for (var i=0; i<contactsList.length; i++) {
               var newID = 'atInserted-' + contactsList[i][1].split('@')[0];
               var html = "\
               <span class='atwho-inserted' id='" + newID + "' style='text-indent: 0.0px;'>\
               <span style='display: inline-table;vertical-align: -3.0px;' contenteditable='false'>\
               <span class='remindName' style='cursor: default;float: left;'>\
               <img name='hideEditorBar' src='http://appmail.mail.10086.cn/m2015/images/global/text_a.png' style='float: left;margin-left:0;margin-right:0;width:auto;'>\
               <em style='margin: 0;padding: 0;background: rgb(255,153,33);font-size: 14.0px;color: rgb(255,255,255);font-weight: normal;padding: 0 5.0px 0 5.0px;height: 20.0px;font-style: normal;font-family: 微软雅黑;line-height: 20.0px;float: left;'>@" + contactsList[i][0] + "</em>\
               <img name='hideEditorBar' src='http://appmail.mail.10086.cn/m2015/images/global/text_c.png' style='float: left;margin-left:0;margin-right:0;width:auto;'>\
               <input type='hidden' name='calendar' style='display: none;'>\
               <input class='tempClassATList' type='hidden' name='address' value='" + contactsList[i][1] + "' style='display: none;'>\
               </span></span></span> ";

               document.execCommand("insertHTML", false, html);
           }
        }

        yhz_editor.getATList = function() {
//           function getATList() {
            var list = document.getElementsByClassName('tempClassATList');
            var ret = [];
            for (var i=0; i<list.length; i++) {
                if (!ret.includes(list[i].value)) {
                    ret.push(list[i].value);
                }
            }
            return ret;
        }

        yhz_editor.cleanATListMark = function () {
            var list = document.getElementsByClassName('tempClassATList');
            var copyList = [];//必须进行复制，不然随着className修改，list会自动删除
            for (var i=0; i<list.length; i++) {
                copyList.push(list[i]);
            }
            for (var i=0; i<copyList.length; i++) {
                copyList[i].className = '';
            }
        }

        yhz_editor.ATListRollback = function (Alist) {
            var list = document.getElementsByName('address');
            for (var i=0; i<list.length; i++) {
                if (Alist.includes(list[i].value)) {
                    list[i].className = 'tempClassATList';
                }
            }
        }

        //主动获取富文本样式
        yhz_editor.getRichStyle = function() {
             setTimeout("getCurrentRichTextStyles()",100);
       }

        //替换@联系人样式，处理web端同步草稿时，背景色块被放大的问题
         yhz_editor.replaceAtStyle = function() {
              var str = document.getElementById("main").innerHTML;
              if(str.indexOf("atwho-inserted") != -1){
                 console.log("grass：该草稿是web端同步草稿");
                 var str2 = str.replace("<img name=\"hideEditorBar\" src=\"http://appmail.mail.10086.cn/m2015/images/global/text_a.png\" style=\"display:inline-block;float:left;\"><em style=\"margin:0;padding:0;background:#ff9921;font-size: 14px;color: #fff;font-weight: normal;padding: 0 5px 0 5px;height:20px;font-style: normal;display:inline-block;font-family: '微软雅黑';line-height: 20px;float:left;\">","<img name=\"hideEditorBar\" src=\"http://appmail.mail.10086.cn/m2015/images/global/text_a.png\" style=\"float: left;margin-left:0;margin-right:0;width:auto;\"> <span style=\"margin: 0px; background: rgb(255, 153, 33); font-size: 14px; color: rgb(255, 255, 255); padding: 0px 5px; height: 20px; font-family: 微软雅黑; line-height: 20px; float: left;\">");
                 var str3 = str2.replace("<img name=\"hideEditorBar\" id=\"kalendarhIcon\" src=\"http://appmail.mail.10086.cn/m2015/images/global/pic-kalendarh.png\" style=\"margin-left: 6px;  vertical-align: -2px; display:none;\"></em><img name=\"hideEditorBar\" src=\"http://appmail.mail.10086.cn/m2015/images/global/text_c.png\" style=\"display:inline-block;float:left;\"><input type=\"hidden\" name=\"calendar\" style=\"display: none;\">","</span> <img name=\"hideEditorBar\" src=\"http://appmail.mail.10086.cn/m2015/images/global/text_c.png\" style=\"float: left;margin-left:0;margin-right:0;width:auto;\"> <input type=\"hidden\" name=\"calendar\">");
                 document.getElementById("main").innerHTML = str3;
              }
        }

         yhz_editor.printHtml = function() {
              console.log("grass:" + document.getElementById("main").innerHTML);
         }
        /****************************************************************************************/

